-- author Rival

claasCutter = {};

function claasCutter.prerequisitesPresent(specializations)
    return true;
end

function claasCutter:load(savegame)
	if hasXMLProperty(self.xmlFile, "vehicle.blade") then
		print("Warning: vehicle.blade is not used anymore. Use vehicle.blades.blade instead");
	end
	
	self.blades = {};
	local bladI = 0;
	while true do
		local blakey = string.format("vehicle.blades.blade(%d)",bladI);
		local index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, blakey.."#index"));
		local speed = Utils.getNoNil(getXMLFloat(self.xmlFile, blakey.."#speed"), 1);
		if index==nil then
			break;
		end
		bladI = bladI+1;
		self.blades[bladI] = {};
		self.blades[bladI].index = index;
		self.blades[bladI].speed = speed;
		self.blades[bladI].curSpeed = 0;
		self.blades[bladI].dir = 1;
		self.blades[bladI].pos = 0;
	end
	
	
	-- Reel Fruit Objects (rfo)
	self.rfo = {};
	self.rfo.barleyObj = {};
	self.rfo.wheatObj = {};
	self.rfo.used = true;
	
	local mainkey = "vehicle.reelFruitObjects";
	
	if not hasXMLProperty(self.xmlFile, mainkey) then
		self.rfo.used = false;
	end
	
	if self.rfo.used then
		self.reelArmNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, mainkey.."#reelArmNode"));
		self.reelNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, mainkey.."#reelNode"));
		self.maxFruitsPerSpike = Utils.getNoNil(getXMLInt(self.xmlFile, mainkey.."#maxFruitsPerSpike"), 3);
		self.rfo.minMaxX = Utils.getVectorNFromString(getXMLString(self.xmlFile, mainkey.."#minMaxX"), 2);
		--self.reelArmMinRot = Utils.getNoNil(getXMLFloat(self.xmlFile, mainkey.."#reelArmMinRot"), 0);
		self.reelArmMaxRot = Utils.getNoNil(getXMLFloat(self.xmlFile, mainkey.."#reelArmMaxRot"), 20);
		
		local i = 0;
		while true do
			local key = string.format("vehicle.reelFruitObjects.barleyObjAtSpike%d", i+1);
			local index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
			if index==nil then
				break;
			else
				setVisibility(index, false);
			end
			i = i + 1;
			self.rfo.barleyObj[i] = {};
			self.rfo.barleyObj[i][1] = index;
		end
		local j = 0;
		while true do
			local key = string.format("vehicle.reelFruitObjects.wheatObjAtSpike%d", j+1);
			local index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
			if index==nil then
				break;
			else
				setVisibility(index, false);
			end
			j = j + 1;
			self.rfo.wheatObj[j] = {};
			self.rfo.wheatObj[j][1] = index;
		end
		self.numSpikess = (#self.rfo.barleyObj + #self.rfo.wheatObj)/2;
		for k=1, self.numSpikess do
			for l=1, self.maxFruitsPerSpike-1 do
				local fruitBarleyClone = clone(self.rfo.barleyObj[k][1], true);
				local fruitWheatClone = clone(self.rfo.wheatObj[k][1], true);
				setVisibility(fruitBarleyClone, false);
				setVisibility(fruitWheatClone, false);
				table.insert(self.rfo.barleyObj[k], fruitBarleyClone);
				table.insert(self.rfo.wheatObj[k], fruitWheatClone);
			end
		end
		
		self.has2ndReel = getXMLBool(self.xmlFile, mainkey.."#has2ndReel");
		
		if self.has2ndReel then
			self.reelNode2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, mainkey.."#reelNode2"));
			self.rfo2 = {};
			self.rfo2.barleyObj = {};
			self.rfo2.wheatObj = {};
			
			self.rfo2.minMaxX = Utils.getVectorNFromString(getXMLString(self.xmlFile, mainkey.."#minMaxX2"), 2);
			
			i = 0;
			while true do
				local key = string.format("vehicle.reelFruitObjects.barleyObj2AtSpike%d", i+1);
				local index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
				if index==nil then
					break;
				else
					setVisibility(index, false);
				end
				i = i + 1;
				self.rfo2.barleyObj[i] = {};
				self.rfo2.barleyObj[i][1] = index;
			end
			j = 0;
			while true do
				local key = string.format("vehicle.reelFruitObjects.wheatObj2AtSpike%d", j+1);
				local index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
				if index==nil then
					break;
				else
					setVisibility(index, false);
				end
				j = j + 1;
				self.rfo2.wheatObj[j] = {};
				self.rfo2.wheatObj[j][1] = index;
			end
			self.numSpikess2 = (#self.rfo2.barleyObj + #self.rfo2.wheatObj)/2;
			for k=1, self.numSpikess2 do
				for l=1, self.maxFruitsPerSpike-1 do
					local fruitBarleyClone = clone(self.rfo2.barleyObj[k][1], true);
					local fruitWheatClone = clone(self.rfo2.wheatObj[k][1], true);
					setVisibility(fruitBarleyClone, false);
					setVisibility(fruitWheatClone, false);
					table.insert(self.rfo2.barleyObj[k], fruitBarleyClone);
					table.insert(self.rfo2.wheatObj[k], fruitWheatClone);
				end
			end
		end
	end
end
function claasCutter:delete()
end
function claasCutter:mouseEvent(posX, posY, isDown, isUp, button)
end
function claasCutter:keyEvent(unicode, sym, modifier, isDown)
end
function claasCutter:update(dt)
	if self:getIsActive() then
		for bladi=1, #self.blades do
			if self.reelStarted then
				self.blades[bladi].curSpeed = math.min(self.blades[bladi].curSpeed+0.012, self.blades[bladi].speed);
			else
				self.blades[bladi].curSpeed = math.max(self.blades[bladi].curSpeed-0.015, 0);
			end
			if self.blades[bladi].pos >= 0.08 then self.blades[bladi].dir=-1 elseif self.blades[bladi].pos <= -0.08 then self.blades[bladi].dir=1 end
			self.blades[bladi].pos = self.blades[bladi].pos+(0.0125*self.blades[bladi].curSpeed*self.blades[bladi].dir);
			setTranslation(self.blades[bladi].index, self.blades[bladi].pos,0,0);
		end

		if self.rfo.used then
			local rotArmX,_,_ = getRotation(self.reelArmNode);
			rotArmX = math.deg(rotArmX);
			
			local rotX,_,_ = math.deg(math.abs(getRotation(self.reelNode)))%360;
			
			if self.reelStarted and self.lastCutterAreaBiggerZero then
				if self.currentInputFruitType == FruitUtil.FRUITTYPE_BARLEY then
					for i=1, self.maxFruitsPerSpike do
						local isActive = math.random(1,math.max(rotArmX-self.reelArmMaxRot+1,1)^2)==1;
						if isActive then
							local _,by,bz = getTranslation(self.rfo.barleyObj[math.floor(rotX/60)+1][i]);
							local bx = math.random(self.rfo.minMaxX[1]*100, self.rfo.minMaxX[2]*100)/100;
							setTranslation(self.rfo.barleyObj[math.floor(rotX/60)+1][i], bx, by, bz);
							setVisibility(self.rfo.barleyObj[math.floor(rotX/60)+1][i], true);
						end
						if self.has2ndReel then
							local rotX2,_,_ = math.deg(math.abs(getRotation(self.reelNode2)))%360;
							local isActive2 = math.random(1,math.max(rotArmX-self.reelArmMaxRot+1,1)^2)==1;
							if isActive2 then
								local _,by,bz = getTranslation(self.rfo2.barleyObj[math.floor(rotX2/60)+1][i]);
								local bx = math.random(self.rfo2.minMaxX[1]*100, self.rfo2.minMaxX[2]*100)/100;
								setTranslation(self.rfo2.barleyObj[math.floor(rotX2/60)+1][i], bx, by, bz);
								setVisibility(self.rfo2.barleyObj[math.floor(rotX2/60)+1][i], true);
							end
						end
					end
				end
				if self.currentInputFruitType == FruitUtil.FRUITTYPE_WHEAT then
					for i=1, self.maxFruitsPerSpike do
						local isActive = math.random(1,math.max(rotArmX-self.reelArmMaxRot+1,1)^2)==1;
						if isActive then
							local _,by,bz = getTranslation(self.rfo.wheatObj[math.floor(rotX/60)+1][i]);
							local bx = math.random(self.rfo.minMaxX[1]*100, self.rfo.minMaxX[2]*100)/100;
							setTranslation(self.rfo.wheatObj[math.floor(rotX/60)+1][i], bx, by, bz);
							setVisibility(self.rfo.wheatObj[math.floor(rotX/60)+1][i], true);
						end
						if self.has2ndReel then
							local rotX2,_,_ = math.deg(math.abs(getRotation(self.reelNode2)))%360;
							local isActive2 = math.random(1,math.max(rotArmX-self.reelArmMaxRot+1,1)^2)==1;
							if isActive2 then
								local _,by,bz = getTranslation(self.rfo2.wheatObj[math.floor(rotX2/60)+1][i]);
								local bx = math.random(self.rfo2.minMaxX[1]*100, self.rfo2.minMaxX[2]*100)/100;
								setTranslation(self.rfo2.wheatObj[math.floor(rotX2/60)+1][i], bx, by, bz);
								setVisibility(self.rfo2.wheatObj[math.floor(rotX2/60)+1][i], true);
							end
						end
					end
				end
			end
			for i=1, self.numSpikess do
				local spikeI = math.floor(rotX/60)+2;
				if spikeI > 6 then spikeI = spikeI - 6; end
				if spikeI == i then
					for j=1, self.maxFruitsPerSpike do
						setVisibility(self.rfo.wheatObj[i][j], false);
						setVisibility(self.rfo.barleyObj[i][j], false);
					end
				end
			end
			if self.has2ndReel then
				for i=1, self.numSpikess2 do
					local rotX2,_,_ = math.deg(math.abs(getRotation(self.reelNode2)))%360;
					local spikeI2 = math.floor(rotX2/60)+2;
					if spikeI2 > 6 then spikeI2 = spikeI2 - 6; end
					if spikeI2 == i then
						for j=1, self.maxFruitsPerSpike do
							setVisibility(self.rfo2.wheatObj[i][j], false);
							setVisibility(self.rfo2.barleyObj[i][j], false);
						end
					end
				end
			end
		end
	end
end
function claasCutter:updateTick(dt)
end
function claasCutter:draw()
end